/* E-Chronometer: A simple chronometer epplet :)
 * Version: 0.1 Saturday November 20, 1999
 * 
 * Copyright (C) 1999 Antonio Ognio Cesti (The Gnrfan)
 *
 * e-mail   : ognio@altavista.net
 * homepage : http://gnrfan.htmlplanet.com/
 *
 * Hey, everybody learning the Epplets API is invited to hack on
 * this code and add stuff... Remember to post me all changes by
 * mail so I can track how this little epplet is evolving.. :)
 *
 * It's a pleasure to re-learn C and start with Linux / X programming
 * with this wonderful API.. Thanks Raster, Mandrake and team.
 *
 * This program is free software and is distributed under the terms
 * of the GNU GPL (Thanks RMS for the great work!) so please READ THE
 * COPYING file if you are new to the whole opensource/freesoftware 
 * thing.
 *
 * Be sure to read MY REPLIES to the question in the Interview for
 * Epplets demonishi posted to e.themes.org in the INTERVIEW file!
 *
 * And of course read the REAME :)
 *
 * Do yourself a favor: Learn to program Epplets! :)
 *
 * Antonio es PERUANO y habla ESPANIOL asi que si tu eres un programador
 * en Linux y eres de latinoamerica, el estara mas que contento de entrar
 * en contacto contigo... Sobretodo si tambien vives en Peru! :)
 */

#include <strings.h>
#include "epplet.h"

#define ACTION_STOP   0
#define ACTION_COUNT  1
#define ACTION_PAUSE  2
#define ACTION_RESET  3
#define BLINK_TIME   10 /* In ds */

int  Action_Flag = ACTION_STOP;
int  h, m, s, ds;
int  blink_counter;
   
Epplet_gadget b_close, b_help, b_pause, b_start, b_stop, b_reset, lbl_chron;

static void timer_cb(void *data);
static void close_cb(void *data);
static void help_cb(void *data);
static void start_chronometer_cb(void *data);
static void stop_chronometer_cb(void *data);
static void reset_chronometer_cb(void *data);
static void pause_chronometer_cb(void *data);



static void
timer_cb(void *data)
{
   
  char strbuf[10];
  char *strblank = "          ";
   
   switch(Action_Flag)
   {
    case ACTION_STOP:
    {
    
       break;

    }
    case ACTION_COUNT:
    {

       ds++;

       if (ds==10)
       {
           ds=0;
           s++;
       }

       if (s==60)
       {        
           s=0;
           m++;
       }

       if (m==60)
       {
           m=0;
           h++;
       }

       if (h==24)
       {
           h=0;
       }

       sprintf(strbuf, "%.2d:%.2d:%.2d:%d",h, m, s, ds);     	
       Epplet_change_label(lbl_chron, strbuf);    
       break;

    }
    case ACTION_PAUSE:
    {
    
       blink_counter++;
       if (blink_counter == BLINK_TIME+1) 
          Epplet_change_label(lbl_chron, strblank);
       if (blink_counter == BLINK_TIME*2) 
       {
          sprintf(strbuf, "%.2d:%.2d:%.2d:%d", h, m, s, ds);
          Epplet_change_label(lbl_chron, strbuf);
          blink_counter = 0;
       }       
       break;

    }
    case ACTION_RESET:
    {
    
       h  = 0;
       m  = 0;
       s  = 0;
       ds = 0; 

       sprintf(strbuf,"%.2d:%.2d:%.2d:%d", h, m, s, ds);
       Epplet_change_label(lbl_chron, strbuf);
       break;
    
    }
   }
   
   Epplet_timer(timer_cb, NULL, 0.1, "TIMER");   
   data = NULL;
}


static void
start_chronometer_cb(void *data)
{
 
   Action_Flag = ACTION_COUNT;
   Epplet_gadget_show(b_pause);
   Epplet_gadget_hide(b_start);
   
}

static void
pause_chronometer_cb(void *data)
{

   Action_Flag   = ACTION_PAUSE;
   blink_counter = 0;
   Epplet_gadget_show(b_start);
   Epplet_gadget_hide(b_pause);

}


static void
reset_chronometer_cb(void *data)
{

   Action_Flag = ACTION_RESET;
   Epplet_gadget_show(b_start);
   Epplet_gadget_hide(b_reset);

}

static void
stop_chronometer_cb(void *data)
{
   Action_Flag = ACTION_STOP;
   Epplet_gadget_show(b_reset);
   Epplet_gadget_hide(b_start);
   Epplet_gadget_hide(b_pause);
}

static void
close_cb(void *data)
{
   Epplet_unremember();
   Esync();
   Epplet_cleanup();
   data = NULL;
   exit(0);
}

static void
help_cb(void *data)
{

    Epplet_show_about("E-Chronometer");

}


int
main(int argc, char **argv)
{

   Epplet_Init("E-Chronometer", "0.1", "A simple Chronometer Epplet",
	       7, 1, argc, argv, 0);

   Epplet_gadget_show(b_close = Epplet_create_button(NULL, NULL, 
				2, 2, 0, 0, "CLOSE", 0, NULL, 
				close_cb, NULL));

   Epplet_gadget_show(b_help  = Epplet_create_button(NULL, NULL,
                                16, 2, 0, 0, "HELP", 0, NULL,
                                help_cb, NULL));  

   Epplet_gadget_show(b_start = Epplet_create_button(NULL, NULL,
                                84, 2, 0, 0, "PLAY", 0, NULL,
                                start_chronometer_cb, NULL));

   		      b_pause = Epplet_create_button(NULL, NULL,
                                84, 2, 0 ,0, "PAUSE", 0, NULL,
                                pause_chronometer_cb, NULL);                                

   Epplet_gadget_show(b_stop  = Epplet_create_button(NULL, NULL,
                                98, 2, 0, 0, "STOP", 0, NULL,
                                stop_chronometer_cb, NULL)); 

                      b_reset = Epplet_create_button(NULL, NULL,
                                84, 2 ,0 ,0 , "REWIND", 0, NULL,
                                reset_chronometer_cb, NULL);

   Epplet_gadget_show(lbl_chron = Epplet_create_label(34, 4, "00:00:00:0", 1));

   Epplet_show();
   timer_cb(NULL); 
   Epplet_Loop();
   return 0;
}
